﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceProcess;
using System.IO;
using System.Diagnostics;

namespace BitMoose.Core {

	public static class BitMooseServiceController {

		public static bool TryGetStatus( out ServiceControllerStatus status ) {
			status = ServiceControllerStatus.Stopped;
			try {
				ServiceController bmservice = new ServiceController( "bitmoose" );
				status = bmservice.Status;
				return true;
			} catch ( InvalidOperationException ) { }
			return false;
		}

		public static void Start() {
			ServiceController bmservice = new ServiceController( "bitmoose" );
			if ( bmservice.Status == ServiceControllerStatus.Stopped ) {
				bmservice.Start();
			} else if ( bmservice.Status == ServiceControllerStatus.Paused ) {
				bmservice.Continue();
			}
		}

		public static void Stop() {
			ServiceController bmservice = new ServiceController( "bitmoose" );
			if ( bmservice.Status == ServiceControllerStatus.Running || bmservice.Status == ServiceControllerStatus.Paused ) {
				bmservice.Stop();
			}
		}

		public static void Restart() {
			Stop();
			Start();
		}

		public static void Install( string appPath ) {
			string args = String.Format( "create \"bitmoose\" start= auto binPath= \"{0}\" DisplayName= \"Bit Moose Mining\"", Path.Combine( appPath, "bitmoose-svc.exe" ) );
			ProcessStartInfo psi = new ProcessStartInfo( "sc", args );
			psi.UseShellExecute = true;
			psi.Verb = "runas";
			Process proc = Process.Start( psi );
		}

		public static void Uninstall() {
			ProcessStartInfo psi = new ProcessStartInfo( "sc", "delete \"bitmoose\"" );
			psi.UseShellExecute = true;
			psi.Verb = "runas";
			Process proc = Process.Start( psi );
		}

	}

}
