﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BitMoose.Core {

	public class HardwareDetector {

		#region " Properties "

		public int CPUPhysical { get; protected set; }

		public int CPUPhysicalCores { get; protected set; }

		public int CPULogicalCores { get; protected set; }

		#endregion

		#region " Methods "

		public void Detect() {
			int count = 0;
			foreach ( var item in new System.Management.ManagementObjectSearcher( "Select * from Win32_ComputerSystem" ).Get() ) {
				count += Convert.ToInt32( item["NumberOfProcessors"] );
			}
			this.CPUPhysical = count;
			count = 0;
			foreach ( var item in new System.Management.ManagementObjectSearcher( "Select * from Win32_Processor" ).Get() ) {
				count += Convert.ToInt32( item["NumberOfCores"] );
			}
			this.CPUPhysicalCores = count;
			count = 0;
			foreach ( var item in new System.Management.ManagementObjectSearcher( "Select * from Win32_ComputerSystem" ).Get() ) {
				count += Convert.ToInt32( item["NumberOfLogicalProcessors"] );
			}
			this.CPULogicalCores = count;
		}

		#endregion

	}

}
