﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using BitMoose.Core.Settings;

namespace BitMoose.App.GUI {

	public partial class DefaultValuesForm : Form {

		private BitMooseSettings Settings = null;

		#region " Constructor(s) "

		public DefaultValuesForm() : this( null ) { }

		public DefaultValuesForm( BitMooseSettings settings ) {
			this.Settings = settings;
			InitializeComponent();
		}

		#endregion

		#region " UI Events "

		private void DefaultValuesForm_Load( object sender, EventArgs e ) {
			PopulateUI();
		}

		private void buttonDone_Click( object sender, EventArgs e ) {
			this.Settings.DefaultMinerOption = this.comboBoxMinerOption.SelectedItem.ToString();
			this.Settings.DefaultPool = this.comboBoxPool.SelectedItem.ToString();
			this.Settings.DefaultUserName = this.textBoxUserName.Text;
			this.Settings.DefaultPassword = this.textBoxPassword.Text;
			this.DialogResult = DialogResult.OK;
			this.Close();
		}

		#endregion

		#region " Methods "

		private void PopulateUI() {
			this.comboBoxPool.Items.Clear();
			for ( int x = 0; x < this.Settings.Pools.Length; x++ ) {
				this.comboBoxPool.Items.Add( this.Settings.Pools[x].Name );
			}
			this.comboBoxPool.SelectedItem = this.Settings.DefaultPool;
			this.comboBoxMinerOption.Items.Clear();
			foreach ( var kvp in this.Settings.MinerOptions ) {
				this.comboBoxMinerOption.Items.Add( kvp.Key );
			}
			this.comboBoxMinerOption.SelectedItem = this.Settings.DefaultMinerOption;
			this.textBoxUserName.Text = this.Settings.DefaultUserName;
			this.textBoxPassword.Text = this.Settings.DefaultPassword;
		}

		#endregion

	}
}
