﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using BitMoose.Core.Settings;

namespace BitMoose.App.GUI {

	public partial class RenameForm : Form {

		private BitMooseSettings Settings = null;
		private string OriginalName = null;

		#region " Properties "

		public string MinerName {
			get { return this.textBoxName.Text; }
		}

		#endregion

		#region " Constructor(s) "

		public RenameForm() : this( null, null ) { }

		public RenameForm( string name, BitMooseSettings settings ) {
			InitializeComponent();
			this.textBoxName.Text = name;
			OriginalName = name;
			this.Settings = settings;
		}

		#endregion

		private void buttonRename_Click( object sender, EventArgs e ) {
			if ( String.IsNullOrEmpty( this.textBoxName.Text ) ) {
				MessageBox.Show( "A name for the miner must be specified.", "Invalid Name", MessageBoxButtons.OK, MessageBoxIcon.Stop );
				return;
			} if ( this.textBoxName.Text.Contains( '*' ) ) {
				MessageBox.Show( "A miner name cannot contain the '*' character.", "Invalid Name", MessageBoxButtons.OK, MessageBoxIcon.Stop );
				return;
			} else if ( this.Settings.Miners.ContainsKey( this.textBoxName.Text ) && this.textBoxName.Text != OriginalName ) {
				MessageBox.Show( "Another miner with the same name aready exists.", "Invalid Name", MessageBoxButtons.OK, MessageBoxIcon.Stop );
				return;
			} else if ( OriginalName == this.textBoxName.Text ) {
				this.DialogResult = DialogResult.Cancel;
				this.Close();
			}
			this.DialogResult = DialogResult.OK;
			this.Close();
		}

	}

}
