﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Diagnostics;
using BitMoose.Core;

namespace BitMoose.App.Test {

	class Program {

		private static Thread ServiceThread = null;
		private static MiningProcessor Processor = null;

		static void Main( string[] args ) {
			//set up tracer
			ConsoleTraceListener consoleLog = new ConsoleTraceListener( false );
			consoleLog.TraceOutputOptions = TraceOptions.None;
			consoleLog.Filter = new EventTypeFilter( SourceLevels.Verbose );
			Trace.Listeners.Add( consoleLog );
			Trace.AutoFlush = true;
			//start wrapper program
			Console.WriteLine( "BitMoose Service-in-Console" );
			Console.WriteLine( "This application runs all miners from the console." );
			Console.WriteLine( "Use BitMoose.exe to configure the windows background service." );
			Console.WriteLine();
			Console.WriteLine( "Starting..." );
			ServiceThread = new Thread( new ThreadStart( StartService ) );
			ServiceThread.Start();
			Console.WriteLine( "Started..." );
			Console.WriteLine( "Press any key to exit..." );
			Console.WriteLine();
			Console.ReadKey( true );
			lock ( Processor ) {
				Processor.Stop();
			}
		}

		public static void StartService() {
			Processor = new MiningProcessor();
			Processor.Start();
		}

	}

}
